local lastUnitUpdate = 0
local function getThrottle()
	local now = Inspect.Time.Frame()
	elapsed = now - lastUnitUpdate
	if (elapsed >= (.5)) then --half a second
		lastUnitUpdate = now
		return true
	end
end

function isRaid()
	rhrgroupfound = false
	rhrraidfound = false
	rhrsolofound = true
	for k, v in pairs(rhr.UnitsTable) do
		if Inspect.Unit.Lookup(v) then
			if k < 6 then rhrraidfound = false rhrgroupfound = true end
			if k > 5 then rhrraidfound = true rhrgroupfound = false end
			rhrsolofound = false
			rhr.groupBF[k]:SetVisible(true)
			if not rhrValues.isincombat then rhr.groupMask[k]:SetVisible(true) end
		else
			rhr.groupBF[k]:SetVisible(false)
			if not rhrValues.isincombat then rhr.groupMask[k]:SetVisible(false) end
		end
	end
	
	if rhrsolofound then
		rhr.QueryTable = rhr.SoloTable
		if processsolo == false then
			processMacroText(rhr.UnitTable)
		end
		rhr.groupBF[1]:SetVisible(true)
		if not rhrValues.isincombat then rhr.groupMask[1]:SetVisible(true) end
		if Inspect.Unit.Lookup("player.pet") and rhrValues.pet then
			rhr.groupBF[6]:SetVisible(true)
			if not rhrValues.isincombat then rhr.groupMask[6]:SetVisible(true) end
		end
	end	
	if rhrgroupfound then
		rhr.QueryTable = rhr.GroupTable
		if processgroup == false then
			processMacroText(rhr.UnitsGroupTable)
		end
		for i = 1, 5 do
			local temppet = string.format("group%.2d", i)..".pet"
			if  rhrValues.pet and Inspect.Unit.Lookup(temppet) then
				rhr.groupBF[i + 5]:SetVisible(true)
				if not rhrValues.isincombat then rhr.groupMask[i + 5]:SetVisible(true) end
			end--petcheck
		end
	end	
	if rhrraidfound then
		rhr.QueryTable = rhr.RaidTable
		if processraid == false then
			processMacroText(rhr.UnitsTable)
		end
	end

end

function rhrUnitUpdate()
	if rhrValues.islocked == false then return end
	timer = getThrottle()
	if not timer then return end
	isRaid()

	local details = Inspect.Unit.Detail(rhr.QueryTable)
	for unitident, unitID in pairs(details) do
		j = stripnum(unitident)
		if (rhrsolofound or rhrgroupfound) and string.find(unitident, "pet") then
--			print (unitident)
			j = j + 5
		end--petcheck
		name = unitID.name
		if string.len(name) > 8 then name = string.sub(name, 1, 8)..".." end
		rhr.groupName[j]:SetText(name)
		if unitID.calling then
			for i = 1, 4 do
				if unitID.calling == rhr.Calling[i] then
					rhr.groupName[j]:SetFontColor(rhrCallingColors[i].r, rhrCallingColors[i].g, rhrCallingColors[i].b, 1)
				end
			end
		else
			rhr.groupName[j]:SetFontColor(1, 1, 1, 1)
		end
		if unitID.role and rhrValues.rolewatch == true then
			rhr.groupRole[j]:SetTexture("RiftHealer", "Textures/"..unitID.role..".png")
		else
			rhr.groupRole[j]:SetTexture("RiftHealer", "Textures/".."blank.png")
		end
		if unitID.offline then
			rhr.groupStatus[j]:SetText("Offline")
			rhr.groupHF[j]:SetWidth(1)
		end
		if unitID.aggro then
			rhr.groupBF[j]:SetTexture("RiftHealer", "Textures/aggroframe.png")
		else
			rhr.groupBF[j]:SetTexture("RiftHealer", "Textures/backframe.png")
		end
		if unitID.blocked then
			rhr.groupHF[j]:SetTexture("RiftHealer", "Textures/healthlos.png")
		else
			rhr.groupHF[j]:SetTexture("RiftHealer", "Textures/"..rhrValues.texture)
		end
        
		if rhrHpUpdated then
			healthtick = unitID.health 
			healthmax = unitID.healthMax
			if healthtick and healthmax ~= nil then
				healthpercent = string.format("%s%%", (math.ceil(healthtick/healthmax * 100)))
				rhr.groupHF[j]:SetWidth((tempx - 10)*(healthtick/healthmax))
				rhr.groupStatus[j]:SetText(healthpercent)
			end
		end
		if rhr.UnitBuffTable[unitident].poison or rhr.UnitBuffTable[unitident].hot then
			local allbuffs = Inspect.Buff.List(unitident)
			if allbuffs then
				buffInfo = Inspect.Buff.Detail(unitident, allbuffs)
				rhr.debuff = {false, false, false}
				rhrbuffhot = false
				for k, v in pairs (buffInfo) do
					--if string.find(retIdent, "pet") then petnum = 5 else petnum = 0 end
					local rbuff = v
					if rhrValues.debuffwatch == true then
						if rbuff.poison then rhr.debuff[1] = true rhr.groupStatus[j]:SetBackgroundColor(0,.6,.3,1) end
						if rbuff.curse then	rhr.debuff[2] = true rhr.groupStatus[j]:SetBackgroundColor(.6,.3,1,1) end
						if rbuff.disease then rhr.debuff[3] = true	rhr.groupStatus[j]:SetBackgroundColor(1,.5,0,1) end
					end
					if rhrValues.hotwatch == true then
						for index, bufflistname in pairs(rhrBuffList) do
							if rbuff.name == bufflistname and Inspect.Unit.Lookup(rbuff.caster) == "player" then rhrbuffhot = true end
						end
					end
				end	
				if rhr.debuff[1] == false and rhr.debuff[2] == false and rhr.debuff[3] == false then
						rhr.groupStatus[j]:SetBackgroundColor(0,0,0,0)
						rhr.UnitBuffTable[unitident].poison = nil
				end
				if rhrbuffhot == false then
					rhr.groupHoT[j]:SetVisible(false)
					rhr.UnitBuffTable[unitident].hot = nil
				end
			end
		end
	end
	rhrHpUpdated = false
end

local function rhrHpUpdate()
rhrHpUpdated = true
end

local function rhrBuffChange(unit, buffs)
if rhrValues.hotwatch == false and rhrValues.debuffwatch == false then return end
local buffUnitTable = Inspect.Unit.Lookup(rhr.QueryTable)
	for retIdent, retID in pairs(buffUnitTable) do
		if unit == retID then
			retnum = stripnum(retIdent)
			if string.find(retIdent, "pet") then petnum = 5 else petnum = 0 end
			retnum = retnum + petnum
			for buffID in pairs(buffs) do
				local buffInfo = Inspect.Buff.Detail(unit, buffID)
				if rhrValues.hotwatch == true then
					if buffInfo.debuff then
						if buffInfo.poison then 
							rhr.groupStatus[retnum]:SetBackgroundColor(0,.6,.3,1)
							rhr.UnitBuffTable[retIdent].poison = true
						end
						if buffInfo.curse then
							rhr.groupStatus[retnum]:SetBackgroundColor(.6,.3,1,1)
							rhr.UnitBuffTable[retIdent].poison = true
						end
						if buffInfo.disease then
							rhr.groupStatus[retnum]:SetBackgroundColor(1,.5,0,1)
							rhr.UnitBuffTable[retIdent].poison = true
						end
					end
				end
				if rhrValues.hotwatch == true then
					for index, bufflistname in pairs(rhrBuffList) do
						if buffInfo.name == bufflistname and Inspect.Unit.Lookup(buffInfo.caster) == "player" then
							rhr.UnitBuffTable[retIdent].hot = true
							rhr.groupHoT[retnum]:SetVisible(true)
						end
					end
				end
			end
		end
	end
end

function toggleLockedWindow(lockcheck)
	if lockcheck == false then
		rhrValues.islocked = false
		rhr.LockButton:SetTexture("RiftHealer", "Textures/lock.png")
		rhr.Window:SetWidth(rhrValues.mainwidth)
		rhr.ResizeButton:SetVisible(true)
		for i = 1, 20 do
			rhr.groupBF[i]:SetVisible(true)
			rhr.groupMask[i]:SetVisible(true)
			rhr.groupStatus[i]:SetBackgroundColor(0,0,0,0)
		end
		processMacroText(rhr.UnitsTable)
		processraid = false
		processgroup = false
	else
		rhrValues.islocked = true
		rhr.LockButton:SetTexture("RiftHealer", "Textures/locked.png")
		rhr.Window:SetWidth(tempx + 4)
		rhr.ResizeButton:SetVisible(false)
		for i = 1, 20 do rhr.groupBF[i]:SetVisible(false) rhr.groupMask[i]:SetVisible(false) end
	end
end

function rhrCombatEnter()
	rhrValues.isincombat = true
	if not rhrValues.islocked  then
		rhrValues.islocked = true
		toggleLockedWindow(true)
	end
end
function rhrCombatLeave()
	rhrValues.isincombat = false
end

local function rhrloadSettings()
	rhr.WindowOptions:SetVisible(false)
	rhr.Window:SetVisible(false)
	if rhrValues == nil then
		rhrValues = {windowstate = true, locmainx = 0, locmainy = 0, mainheight = 300, mainwidth = 500, font = 16, pet = true, texture = "health_g.png", set = 1, hotwatch = true, debuffwatch = true, rolewatch = true, showtooltips = true}
		rhrValues.locmainx = ((UIParent:GetRight() / 2) - 150)
		rhrValues.locmainy = ((UIParent:GetBottom() / 2) - 250)
	end
	if rhrMacroText == nil then
		rhrMacroText = {
		{"target ##", "", "", "", ""},
		{"target ##", "", "", "", ""},
		{"target ##", "", "", "", ""}}
	end
	if rhrMacroButton == nil then
		rhrMacroButton ={
		{{"target ##", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}},
		{{"target ##", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}},
		{{"target ##", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}},	}
	end
	if rhrBuffList == nil then
		rhrBuffList = {"Soothing Stream", "Healing Current"}
	end
	if rhrCallingColors == nil then
		rhrCallingColors = {{r = 1, g = 0, b = 0}, {r = 0, g = 1, b = 0}, {r = 0.6, g = 0.2, b = 0.8}, {r = 1, g = 1, b = 0}, {r = 1, g = 1, b = 1}}
	end
	if rhrValues.hotwatch == nil then rhrValues.hotwatch = true end
	if rhrValues.debuffwatch == nil then rhrValues.debuffwatch = true end
	if rhrValues.rolewatch == nil then rhrValues.rolewatch = true end
	if rhrValues.showtooltips == nil then rhrValues.showtooltips = true end

	rhrValues.islocked = true
	rhrValues.isincombat = false
	rhrCreateWindow()
	rhrCreateAbilityList()
	rhrCreateOptions()
		print ("Welcome to Rift Healer! Type /rhr for commands.")

end

function rhrShowWindow()
	rhr.Window:SetVisible(true)
	rhrValues.windowstate = true
end

function rhrHideWindow()
	rhr.Window:SetVisible(false)
	rhrValues.windowstate = false
end

local function rhrSlashCommand(params)
	if string.find(params, "set%d") then
		j = tonumber(string.sub(params, string.find(params, "%d")))
		if j > 3 and j < 1 then print ("There are only 3 sets :P") else
		rhrValues.set = j
		processMacroText(rhr.UnitsTable)
		end
	elseif params == "reset" then
		rhr.Window:SetVisible(false)
		rhrValues = nil
		rhrValues = {windowstate = true, locmainx = 0, locmainy = 0, mainheight = 300, mainwidth = 500, font = 16, pet = true, texture = "health_g.png", set = 1, hotwatch = true, debuffwatch = true, rolewatch = true, showtooltips = true}
		rhrMacroText = nil
		rhrMacroText = {
		{"target ##", "", "", "", ""},
		{"target ##", "", "", "", ""},
		{"target ##", "", "", "", ""}}
		rhrMacroButton = nil
		rhrMacroButton ={
		{{"", "", "", "target ##"}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}},
		{{"", "", "", "target ##"}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}},
		{{"", "", "", "target ##"}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}, {"", "", "", ""}},	}
		rhrValues.locmainx = ((UIParent:GetRight() / 2) - 150)
		rhrValues.locmainy = ((UIParent:GetBottom() / 2) - 250)
		rhr.Window:SetPoint("TOPLEFT", context, "TOPLEFT", rhrValues.locmainx, rhrValues.locmainy)
		rhr.WindowReset:SetVisible(true)
	elseif params == "show" then
			rhrShowWindow()
	elseif params == "hide" then
			rhrHideWindow()
	else
		print ("----------------------")
		print ("Rift Healer Help Menu")
		print ("----------------------")
		print ("/rhr show   -- Show window")
		print ("/rhr hide   -- Hide window")
		print ("/rhr reset  -- Reset default addon settings")
		print ("/rhr set#   -- Change sets: 1, 2, 3 only")
	end
end

table.insert(Command.Slash.Register("rhr"), {rhrSlashCommand, "RiftHealer", "rhrSlashCommand"})
table.insert(Event.Addon.Startup.End, {rhrloadSettings, "RiftHealer", "rhrloadSettings"})

table.insert(Event.System.Secure.Enter, {rhrCombatEnter, "RiftHealer", "rhrCombatEnter"})
table.insert(Event.System.Secure.Leave, {rhrCombatLeave, "RiftHealer", "rhrCombatLeave"})

table.insert(Event.Unit.Detail.Health, {rhrHpUpdate, "RiftHealer", "Update_Health"})
table.insert(Event.Unit.Detail.HealthMax, {rhrHpUpdate, "RiftHealer", "Update_Max_Health"})

table.insert(Event.Buff.Add, {rhrBuffChange, "RiftHealer", "BuffAdd"})
table.insert(Event.Buff.Change, {rhrBuffChange, "RiftHealer", "BuffChange"})

table.insert(Event.System.Update.Begin, {rhrUnitUpdate, "RiftHealer", "UpdateGroupDetails"})
